#include <stdio.h>


/*
 1.二进制转十进制
 0b1100 = 0 * 2的0次方 + 0 * 2的1次方 + 1 * 2的2次方+ 1 * 2的3次方
        = 0 + 0 + 4 + 8 = 12
 0b1111 = 1 + 2 + 4 + 8 = 15
 0b1010 = 10
 
 2.十进制转二进制
 67 = 64 + 2 + 1 = 2的6次方 + 2的1次方 + 2的0次方
    = 0b1000000 + 0b10 + 0b1
  = 0b1000011
 
 3.n位二进制的取值范围
 2位二进制位的取值范围：0~3  0~2的2次方-1
 3位二进制位的取值范围：0~7  0~2的3次方-1
 n位二进制位的取值范围：0~2的n次方-1
 
 
 4个字节 -> 31bit
 0    000 0000 0000 0000 0000 0000 0000 1100
 0 ~ 2的31次方-1
 */

int main()
{
    void putBinary(int);
    
    putBinary(-12);
    
    putBinary(13);

    return 0;
}

// 输出一个整数的二进制存储形式
void putBinary(int n)
{
    int bits = sizeof(n) * 8;
    while (bits-->0) {
        printf("%d", n>>bits&1);
        if (bits%4==0) printf(" ");
    }
    printf("\n");
}
