/*
根据变量的作用域，可以分为：
 1.局部变量：
 1> 定义：在函数（代码块）内部定义的变量(包括函数的形参)
 2> 作用域：从定义变量的那一行开始，一直到代码块结束
 3> 生命周期：从定义变量的那一行开始分配存储空间，代码块结束后，就会被回收
 4> 没有固定的初始值
 
 2.全局变量
 1> 定义：在函数外面定义的变量
 2> 作用域：从定义变量的那一行开始，一直到文件结尾(能被后面的所有函数共享)
 3> 生命周期：程序一启动就会分配存储空间，程序退出时才会被销毁
 4> 默认的初始值就是0
*/
#include <stdio.h>

int age;

void test()
{
    int age;
    age = 10;
}

int main()
{
    printf("%d\n", age);// 0
    
    int age = 20;
    
    printf("%d\n", age);// 20
    
    test();
    
    printf("%d\n", age);// 20
    return 0;
}