/*
 提示用户输入一个正整数n，求出并输出下列结果：1! + 2! + 3! + 4! + ... + n!
 要求：用至少两种方式实现(函数名自拟，函数个数不限)
 1> 非递归
 2> 递归
*/
#include <stdio.h>
int pieAdd(int n);

int main()
{
    // 1.定义变量存储用户输入的整数
    int n = 0;
    
    // 2.判断n是否为正整数
    while (n <= 0)
    {
        // 2.1 提示输入
        printf("输入一个正整数：\n");
        
        // 2.2 让用户输入
        scanf("%d", &n);
    }
    
    // 3.计算结果
    int result = pieAdd(n);
    
    printf("结果是%d\n", result);
    
    return 0;
}

// ------------------非递归的方式----------------
int pieAdd(int n)
{
    // 1.定义变量保存总和
    int sum = 0;
    
    // 2.需要累加n次，每次累加的都是一个阶乘值
    for (int i = 1; i<=n; i++)
    {
        // 3.计算阶乘i!
        // 3.1 定义变量保存阶乘的结果
        int multi = 1;
        for (int j = 1; j<=i; j++)
        {
            multi *= j;
        }
        
        // 4.累加每次的阶乘结果
        sum += multi;
    }
    
    // 5.返回和
    return sum;
}

/*
// ------------------递归的方式----------------
// 为了代码方便和性能，额外定义一个函数求阶乘
int jieCheng(int n)
{
    // 如果n为1，那么阶乘值就是1
    if (n == 1) return 1;
    
    // jieCheng(n) = n! = 1*2*3*...*(n-1)*n
    // jieCheng(n-1) = (n-1)! = 1*2*3*...*(n-1)
    // jieCheng(n) = jieCheng(n-1) * n
    return jieCheng(n-1) * n;
}

int pieAdd(int n)
{
    // 1.如果n是1，计算结果就是1
    if (n == 1) return 1;
    
    // pieAdd(n) = 1! + 2! + ... + (n-1)!+ n! 
    // pieAdd(n-1) = 1! + 2! + ... + (n-1)!
    // pidAdd(n) = pieAdd(n-1) + n!
    return pieAdd(n - 1) + jieCheng(n);
}*/