/*
设计一个函数：将一维整型数组中的元素逆序存放。比如本来是1,3,4,2，逆序存放就变成了：2，4，3，1
*/
#include <stdio.h>
void reverse(int array[], int len);

int main()
{
    int ages[4] = {1, 3, 4, 2};
    
    reverse(ages, 4);
    
    for (int i = 0; i<4; i++)
    {
        printf("%d\n", ages[i]);
    }
    
    return 0;
}

// 第一个参数是数组，第二个参数是数组长度
// 不需要返回值
// 因为改变了形参数组就相当于修改了外面的实参数组
void reverse(int array[], int len)
{
    // 思路：以数组中间为轴，交换左右对称元素的值
    // 比如array[0] array[1] array[2] array[3] array[4] array[5]
    // 交换array[0]和array[5]的值
    // 交换array[1]和array[4]的值
    // 交换array[2]和array[3]的值
    
    // 左边元素的下标(默认是最左边)
    int left = 0;
    // 右边元素的下标(默认是最右边)
    int right = len - 1;
    
    // 如果左边元素的下标 < 右边元素的下标
    while (left < right)
    {
        // 利用中间变量交换两个元素的值
        int temp = array[left];
        array[left] = array[right];
        array[right] = temp;
        
        // 交换一次后，左边元素下标增加，右边元素下标减小
        
        left++;
        right--;
    }
}